/***************************************************************************
                           cfile.h  -  description
                             -------------------
    begin                : Wed Apr 3 2003
    copyright            : (C) 2003 by Mathias Kster
    email                : mathen@ketelhot.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CFILE_H
#define CFILE_H

/**
  *@author Mathias Kster
  */

#include <dclib/dcos.h>
#include <dclib/core/cstring.h>
#include <dclib/core/cobject.h>

#define IO_RAW			0x0001
#define IO_READONLY		0x0002
#define IO_WRITEONLY		0x0004
#define IO_READWRITE		0x0008
#define IO_APPEND		0x0010
#define IO_TRUNCATE		0x0020
#define IO_CREAT		0x0040

#define MO_IRWXU 0000700    /* RWX mask for owner */
#define MO_IRUSR 0000400    /* R for owner */
#define MO_IWUSR 0000200    /* W for owner */
#define MO_IXUSR 0000100    /* X for owner */

#define MO_IRWXG 0000070    /* RWX mask for group */
#define MO_IRGRP 0000040    /* R for group */
#define MO_IWGRP 0000020    /* W for group */
#define MO_IXGRP 0000010    /* X for group */

#define MO_IRWXO 0000007    /* RWX mask for other */
#define MO_IROTH 0000004    /* R for other */
#define MO_IWOTH 0000002    /* W for other */
#define MO_IXOTH 0000001    /* X for other */

class DLL_EXPORT CFile : public CObject {

public:
	/** */
	CFile();
	/** */
	virtual ~CFile();

	/** */
	bool Open( CString filename, int mode, int acc = 0 );
	/** */
	bool IsOpen() { return (m_nFD!=-1); };
	/** */
	void Close();
	/** */
	long Write( const char * buf, long count );
	/** */
	long Read( char * buf, long count );
	/** */
	bool Seek( ulonglong offset, int origin );

private:
	/** */
	int m_nFD;
};

#endif
